#include <QString>
#include <QFile>

#include "downloader.h"

downloader::downloader(int ID, int usefix, QString url, QString output)
{
    this->ID=ID;
    progress1=progress2=0;
    outputfile=output;
    script.start( "rtmpdump-yle --rtmp rtmp://flashk.yle.fi/AreenaServer --swfUrl http://areena.yle.fi/player/Application.swf?build=1 --timeout 60 --autoResume 5 --pageUrl "+url);
    timer=new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(pollProcess()));
    timer->start(500);
    this->usefix=usefix;
}



void downloader::pollProcess()
{
     static int progress=1;
     static int totaltime=0;
     QString line;
     QString percent;

      if( script.state()!=0 )
      {
            outputstring+=QString( script.readAllStandardError ());
            line="";
            for(int i=0;i<outputstring.length();i++)
            {
                if(outputstring[i]!='\r')
                {
                    line+=outputstring[i];
                }
                else
                {
                    //Download
                  if(progress==1)
                  {
                    bool found=false;
                    bool endfound=false;
                    int end,start;
                    start=end=0;
                    for(int ii=line.length()-1;ii>=0;ii--)
                    {
                        if(line[ii]=='%')
                        {
                            end=ii;
                            found=true;
                        }

                        if(found && line[ii]=='(')
                        {
                            start=ii;
                            endfound=true;
                            break;
                        }

                    }
                    if(endfound)
                    {
                        percent=line.mid(start+1, end-start-1);
                        progress1=(int)percent.toFloat();
                    }

                    int indexi=outputstring.indexOf("Saving to", 0, Qt::CaseInsensitive);
                    if(indexi!=-1)
                    {
                        filename=outputstring.mid(indexi+10,outputstring.indexOf("\n", indexi)-3-(indexi+10));
                    }



                    line="";
                    outputstring.remove(0, i);
                    timer->start(1000);
                  }
                  //ffmpeg..
                  else
                  {
                        QString temppi;
                        int hour,min,sec;
                        int indexi=line.indexOf("Duration: ");
                        if(indexi!=-1)
                        {
                            temppi=QString(line[indexi+10])+QString(line[indexi+11]);
                            hour=temppi.toInt();
                            temppi=QString(line[indexi+13])+QString(line[indexi+14]);
                            min=temppi.toInt();
                            temppi=QString(line[indexi+16])+QString(line[indexi+17]);
                            sec=temppi.toInt();
                            totaltime=hour*60*60+min*60+sec;
                        }

                        indexi=line.indexOf("time=");
                        if(indexi!=-1)
                        {
                            temppi="";
                            for(int ii=indexi+5;ii<line.length();ii++)
                            {
                                if(line[ii]==' ') break;
                                temppi+=QString(line[ii]);
                            }
                            progress2=(int)((temppi.toFloat()/totaltime)*100);

                        }
                        timer->start(200);
                    }
                }
            }
            Q_EMIT valueChanged(ID, progress1, progress2, 0, "");
      }
      else
      {
        outputstring+=QString( script.readAllStandardError ());

        //if Error
        int indexi=outputstring.indexOf("ERROR");
        if(indexi!=-1)
        {
            progress=1;
            timer->stop();
            Q_EMIT valueChanged(ID, 100,100,1, outputstring.mid(indexi));            
            return;
        }

        //Download completed
        if(progress==1)
        {
            Q_EMIT valueChanged(ID, 100,0,0, "");
            progress++;
            if(usefix)
            {
                script.start("ffmpeg -y -vcodec copy -acodec copy -i \""+filename+"flv\" \""+outputfile+((outputfile.length()==0)?"":"/")+filename+"mp4\"");
            }
            else
            {
                QFile::copy(filename+"flv.",outputfile+((outputfile.length()==0)?"":"/")+filename+"mp4");
            }
        }
        //FFMPEG fix/copy completed
        else
        {
            QFile::remove(filename+"flv");
            timer->stop();
            progress=1;
            Q_EMIT valueChanged(ID, 100,100,0, "");
        }

      }

}
